package dev.shadowsoffire.apotheosis.ench.compat;

import java.util.HashMap;
import java.util.Iterator;
import net.minecraft.util.FormattedCharSequence;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.network.chat.FormattedText;
import net.minecraft.client.gui.Font;
import net.minecraft.ChatFormatting;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.enchantments.InertEnchantment;
import java.util.ArrayList;
import com.mojang.blaze3d.systems.RenderSystem;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import net.minecraft.client.gui.screens.inventory.EnchantmentNames;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiGraphics;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.gui.builder.IRecipeSlotBuilder;
import java.util.List;
import java.util.Arrays;
import mezz.jei.api.recipe.RecipeIngredientRole;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.ingredients.IIngredientType;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.Blocks;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.helpers.IGuiHelper;
import net.minecraft.network.chat.Component;
import mezz.jei.api.gui.drawable.IDrawable;
import java.util.Map;
import mezz.jei.api.recipe.RecipeType;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import mezz.jei.api.recipe.category.IRecipeCategory;

public class EnchantingCategory implements IRecipeCategory<EnchantingRecipe>
{
    public static final ResourceLocation UID;
    public static final RecipeType<EnchantingRecipe> TYPE;
    public static final ResourceLocation TEXTURES;
    private static final Map<Class<?>, Extension<?>> EXTENSIONS;
    private final IDrawable background;
    private final IDrawable icon;
    private final Component localizedName;
    
    public EnchantingCategory(final IGuiHelper guiHelper) {
        this.background = (IDrawable)guiHelper.createDrawable(EnchantingCategory.TEXTURES, 0, 0, 170, 56);
        this.icon = guiHelper.createDrawableIngredient((IIngredientType)VanillaTypes.ITEM_STACK, (Object)new ItemStack((ItemLike)Blocks.f_50201_));
        this.localizedName = (Component)Component.m_237115_("apotheosis.recipes.enchanting");
    }
    
    public IDrawable getBackground() {
        return this.background;
    }
    
    public IDrawable getIcon() {
        return this.icon;
    }
    
    public Component getTitle() {
        return this.localizedName;
    }
    
    public RecipeType<EnchantingRecipe> getRecipeType() {
        return EnchantingCategory.TYPE;
    }
    
    public void setRecipe(final IRecipeLayoutBuilder builder, final EnchantingRecipe recipe, final IFocusGroup focuses) {
        final IRecipeSlotBuilder input = builder.addSlot(RecipeIngredientRole.INPUT, 6, 6);
        final IRecipeSlotBuilder output = builder.addSlot(RecipeIngredientRole.OUTPUT, 37, 6);
        final Extension<?> ext = EnchantingCategory.EXTENSIONS.get(recipe.getClass());
        if (ext != null) {
            ext.setRecipe(builder, input, output, recipe, focuses);
        }
        else {
            input.addIngredients((IIngredientType)VanillaTypes.ITEM_STACK, (List)Arrays.asList(recipe.getInput().m_43908_()));
            output.addIngredient((IIngredientType)VanillaTypes.ITEM_STACK, (Object)recipe.getOutput());
        }
    }
    
    public void draw(final EnchantingRecipe recipe, final IRecipeSlotsView slots, final GuiGraphics gfx, final double mouseX, final double mouseY) {
        boolean hover = false;
        if (mouseX > 57.0 && mouseX <= 165.0 && mouseY > 4.0 && mouseY <= 23.0) {
            gfx.m_280398_(EnchantingCategory.TEXTURES, 57, 4, 0, 0.0f, 71.0f, 108, 19, 256, 256);
            hover = true;
        }
        final Font font = Minecraft.m_91087_().f_91062_;
        final EnchantingStatRegistry.Stats stats = recipe.getRequirements();
        final EnchantingStatRegistry.Stats maxStats = recipe.getMaxRequirements();
        gfx.m_280056_(font, I18n.m_118938_("gui.apotheosis.enchant.eterna", new Object[0]), 16, 26, 4044093, false);
        gfx.m_280056_(font, I18n.m_118938_("gui.apotheosis.enchant.quanta", new Object[0]), 16, 36, 16536660, false);
        gfx.m_280056_(font, I18n.m_118938_("gui.apotheosis.enchant.arcana", new Object[0]), 16, 46, 11010216, false);
        final int level = (int)(stats.eterna() * 2.0f);
        final String s = "" + level;
        final int width = 86 - font.m_92895_(s);
        EnchantmentNames.m_98734_().m_98735_((long)recipe.m_6423_().hashCode());
        final FormattedText itextproperties = EnchantmentNames.m_98734_().m_98737_(font, width);
        int color = hover ? 16777088 : 6839882;
        drawWordWrap(font, itextproperties, 77, 6, width, color, gfx);
        color = 8453920;
        gfx.m_280488_(font, s, 77 + width, 13, color);
        final int[] pos = { (int)(stats.eterna() / EnchantingStatRegistry.getAbsoluteMaxEterna() * 110.0f), (int)(stats.quanta() / 100.0f * 110.0f), (int)(stats.arcana() / 100.0f * 110.0f) };
        if (stats.eterna() > 0.0f) {
            gfx.m_280163_(EnchantingCategory.TEXTURES, 56, 27, 0.0f, 56.0f, pos[0], 5, 256, 256);
        }
        if (stats.quanta() > 0.0f) {
            gfx.m_280163_(EnchantingCategory.TEXTURES, 56, 37, 0.0f, 61.0f, pos[1], 5, 256, 256);
        }
        if (stats.arcana() > 0.0f) {
            gfx.m_280163_(EnchantingCategory.TEXTURES, 56, 47, 0.0f, 66.0f, pos[2], 5, 256, 256);
        }
        RenderSystem.enableBlend();
        if (maxStats.eterna() > 0.0f) {
            gfx.m_280163_(EnchantingCategory.TEXTURES, 56 + pos[0], 27, (float)pos[0], 90.0f, (int)((maxStats.eterna() - stats.eterna()) / EnchantingStatRegistry.getAbsoluteMaxEterna() * 110.0f), 5, 256, 256);
        }
        if (maxStats.quanta() > 0.0f) {
            gfx.m_280163_(EnchantingCategory.TEXTURES, 56 + pos[1], 37, (float)pos[1], 95.0f, (int)((maxStats.quanta() - stats.quanta()) / 100.0f * 110.0f), 5, 256, 256);
        }
        if (maxStats.arcana() > 0.0f) {
            gfx.m_280163_(EnchantingCategory.TEXTURES, 56 + pos[2], 47, (float)pos[2], 100.0f, (int)((maxStats.arcana() - stats.arcana()) / 100.0f * 110.0f), 5, 256, 256);
        }
        RenderSystem.disableBlend();
        final Screen scn = Minecraft.m_91087_().f_91080_;
        if (scn == null) {
            return;
        }
        if (hover) {
            final List<Component> list = new ArrayList<Component>();
            list.add((Component)Component.m_237110_("container.enchant.clue", new Object[] { ((InertEnchantment)Ench.Enchantments.INFUSION.get()).m_44700_(1).getString() }).m_130944_(new ChatFormatting[] { ChatFormatting.GRAY, ChatFormatting.ITALIC }));
            gfx.m_280666_(font, (List)list, (int)mouseX, (int)mouseY);
        }
        else if (mouseX > 56.0 && mouseX <= 166.0 && mouseY > 26.0 && mouseY <= 32.0) {
            final List<Component> list = new ArrayList<Component>();
            list.add((Component)Component.m_237115_("gui.apotheosis.enchant.eterna").m_130940_(ChatFormatting.GREEN));
            if (maxStats.eterna() == stats.eterna()) {
                list.add((Component)Component.m_237110_("info.apotheosis.eterna_exact", new Object[] { stats.eterna(), EnchantingStatRegistry.getAbsoluteMaxEterna() }).m_130940_(ChatFormatting.GRAY));
            }
            else {
                list.add((Component)Component.m_237110_("info.apotheosis.eterna_at_least", new Object[] { stats.eterna(), EnchantingStatRegistry.getAbsoluteMaxEterna() }).m_130940_(ChatFormatting.GRAY));
                if (maxStats.eterna() > -1.0f) {
                    list.add((Component)Component.m_237110_("info.apotheosis.eterna_at_most", new Object[] { maxStats.eterna(), EnchantingStatRegistry.getAbsoluteMaxEterna() }).m_130940_(ChatFormatting.GRAY));
                }
            }
            gfx.m_280666_(font, (List)list, (int)mouseX, (int)mouseY);
        }
        else if (mouseX > 56.0 && mouseX <= 166.0 && mouseY > 36.0 && mouseY <= 42.0) {
            final List<Component> list = new ArrayList<Component>();
            list.add((Component)Component.m_237115_("gui.apotheosis.enchant.quanta").m_130940_(ChatFormatting.RED));
            if (maxStats.quanta() == stats.quanta()) {
                list.add((Component)Component.m_237110_("info.apotheosis.percent_exact", new Object[] { stats.quanta() }).m_130940_(ChatFormatting.GRAY));
            }
            else {
                list.add((Component)Component.m_237110_("info.apotheosis.percent_at_least", new Object[] { stats.quanta() }).m_130940_(ChatFormatting.GRAY));
                if (maxStats.quanta() > -1.0f) {
                    list.add((Component)Component.m_237110_("info.apotheosis.percent_at_most", new Object[] { maxStats.quanta() }).m_130940_(ChatFormatting.GRAY));
                }
            }
            gfx.m_280666_(font, (List)list, (int)mouseX, (int)mouseY);
        }
        else if (mouseX > 56.0 && mouseX <= 166.0 && mouseY > 46.0 && mouseY <= 52.0) {
            final List<Component> list = new ArrayList<Component>();
            list.add((Component)Component.m_237115_("gui.apotheosis.enchant.arcana").m_130940_(ChatFormatting.DARK_PURPLE));
            if (maxStats.arcana() == stats.arcana()) {
                list.add((Component)Component.m_237110_("info.apotheosis.percent_exact", new Object[] { stats.arcana() }).m_130940_(ChatFormatting.GRAY));
            }
            else {
                list.add((Component)Component.m_237110_("info.apotheosis.percent_at_least", new Object[] { stats.arcana() }).m_130940_(ChatFormatting.GRAY));
                if (maxStats.arcana() > -1.0f) {
                    list.add((Component)Component.m_237110_("info.apotheosis.percent_at_most", new Object[] { maxStats.arcana() }).m_130940_(ChatFormatting.GRAY));
                }
            }
            gfx.m_280666_(font, (List)list, (int)mouseX, (int)mouseY);
        }
    }
    
    public static void drawWordWrap(final Font font, final FormattedText pText, final int pX, int pY, final int pMaxWidth, final int pColor, final GuiGraphics gfx) {
        for (final FormattedCharSequence formattedcharsequence : font.m_92923_(pText, pMaxWidth)) {
            gfx.m_280649_(font, formattedcharsequence, pX, pY, pColor, false);
            pY += 9;
        }
    }
    
    public static <T extends EnchantingRecipe> void registerExtension(final Class<T> cls, final Extension<T> ext) {
        EnchantingCategory.EXTENSIONS.put(cls, ext);
    }
    
    static {
        UID = new ResourceLocation("apotheosis", "enchanting");
        TYPE = RecipeType.create("apotheosis", "enchanting", (Class)EnchantingRecipe.class);
        TEXTURES = new ResourceLocation("apotheosis", "textures/gui/enchanting_jei.png");
        EXTENSIONS = new HashMap<Class<?>, Extension<?>>();
    }
    
    public interface Extension<T extends EnchantingRecipe>
    {
        void setRecipe(final IRecipeLayoutBuilder p0, final IRecipeSlotBuilder p1, final IRecipeSlotBuilder p2, final EnchantingRecipe p3, final IFocusGroup p4);
    }
}
